close all
clear all
clc

images = {imread('bladeLeft.bmp'), imread('bladeRight.bmp')};
zoom_size = 600;
pixnum=size(images{1});
boxs=45;



%im = im < 60;
for i = 1:length(images)
    imagesc(images{i})
    title('White part of image')
    [zoomcenx,zoomceny]=ginput(1);
    xlim([zoomcenx-(zoom_size/4) zoomcenx+(zoom_size/4)]),   ylim([zoomceny-(zoom_size/4) zoomceny+(zoom_size/4)])
    [zoomcenx,zoomceny]=ginput(1);
    x1=floor(zoomcenx-(boxs/2));
    x2=ceil(zoomcenx+(boxs/2));
    y1=floor(zoomceny-(boxs/2));
    y2=ceil(zoomceny+(boxs/2));
    calData = load(['cal_dat_00' num2str(i) '.txt']);
    c1pixnum = size(images{i});
    poly_n = 3;
    x = zoomcenx;
    y = zoomceny;
    a=c1pixnum(2)/2; 
    b=c1pixnum(1)/2;
    [sing_c1x_pl1(i)]=polynmapping(x,y,a,b,calData(1:10,1),poly_n); 
    [sing_c1y_pl1(i)]=polynmapping(x,y,a,b,calData(1:10,2),poly_n);
    [sing_c1x_pl2(i)]=polynmapping(x,y,a,b,calData(1:10,3),poly_n);
    [sing_c1y_pl2(i)]=polynmapping(x,y,a,b,calData(1:10,4),poly_n);

end

close all

point1 = [sing_c1x_pl1(1) sing_c1y_pl1(1) -1];
point2 = [sing_c1x_pl2(1) sing_c1y_pl2(1) 0];


point3 = [sing_c1x_pl1(2) sing_c1y_pl2(2) -1];
point4 = [sing_c1x_pl2(2) sing_c1y_pl2(2) 0];

scalingFactor = 200;

point5 = [point1(1) + (point1(1) - point2(1))*scalingFactor, point1(2) + (point1(2) - point2(2))*scalingFactor, point1(3) + (point1(3) - point2(3))*scalingFactor];
point6 = [point2(1) + (point2(1)-point1(1))*scalingFactor, point2(2) + (point2(2)-point1(2))*scalingFactor, point2(3) + (point2(3)-point1(3))*scalingFactor];


point7 = [point3(1) + (point3(1)-point4(1))*scalingFactor, point3(2) + (point3(2)-point4(2))*scalingFactor, point3(3) + (point3(3)-point4(3))*scalingFactor];
point8 = [point4(1) + (point4(1)-point3(1))*scalingFactor, point4(2) + (point4(2)-point3(2))*scalingFactor, point4(3) + (point4(3)-point3(3))*scalingFactor];


[dis, m1, m2, m3] = DistBetween2Segment(point5, point6, point7, point8);
zposition = mean([m3(3) m2(3)]);
yposition = mean([m3(2) m2(2)]);
xposition = mean([m3(1) m2(1)]);
intersection = [xposition yposition zposition];

A1 = [sing_c1x_pl1(1),sing_c1x_pl2(1)];
B1 = [sing_c1y_pl1(1), sing_c1y_pl2(1)];
A2 = [sing_c1x_pl1(2), sing_c1x_pl2(2)];
B2 = [sing_c1y_pl1(2), sing_c1y_pl2(2)];

p1 = polyfit(A1, B1, 1);
p2 = polyfit(A2, B2, 1);
x1 = linspace(A1(1), A1(2), 101);
x2 = linspace(A2(1), A2(2), 101);
y1 = polyval(p1,x1);
y2 = polyval(p2,x2);

figure(2)
plot3([point5(1) point6(1)], [point5(2) point6(2)], [point5(3) point6(3)]);
hold on
plot3([point7(1) point8(1)], [point7(2) point8(2)], [point7(3) point8(3)]);



xlabel('x')
ylabel('y')
zlabel('z')